module ServiceLayerRest
    class UsersController < ApplicationController
        include Base
        include Dll

        def update_user_password
            invalid_key = check_params([:fct_code, :username, :oldpassword, :newpassword, :authtypeFromUser], [])
            return render bad_params_for_render(invalid_key) unless invalid_key.blank?

            begin
            response_string, string_pointer = ServiceLayerDll.update_user_password(
                current_user.as_json,
                params[:fct_code],
                params[:username],
                params[:oldpassword],
                params[:newpassword],
                params[:authtypeFromUser]
            )
            ServiceLayerDll.free_string(string_pointer)

            render parse_response_string_for_render(response_string)
            rescue Exception => e
            render parse_exception_for_render(e)
            end
        end

        def get_clients
            begin
                response_string, string_pointer = ServiceLayerDll.get_clients('', '')
                ServiceLayerDll.free_string(string_pointer)

                render parse_response_string_for_render(response_string)
            rescue Exception => e
                render parse_exception_for_render(e)
            end    
        end
    end
end
