# Aggregated Services for Applications

ServiceLayerRest::Engine.routes.draw do
    scope "/v1" do
        scope "/api" do
            scope "/my-pep" do
                get "/detail_plan" => "my_pep#get_detail_plan"
                get "/informations" => "my_pep#get_informations"
                get "/year_plan" => "my_pep#get_year_plan"
                get "/group_plan" => "my_pep#get_group_plan"
                get "/daily_data_details/" => "my_pep#get_daily_data_details"
                put "/daily_data_duty_requests" => "my_pep#delete_daily_data_duty_requests" # Should be delete, but the framework doesn't allow it
                
                scope "/definitions" do
                    get "/" => "my_pep#get_definitions"
                    put "/datearray" => "my_pep#get_definitions_for_datearray" # Should be a GET, is a PUT cause og length
                end  
                
                scope "/timesheet" do
                    get "/" => "my_pep#load_timesheet"
                    put "/" => "my_pep#update_timesheet"
                    put "/item" => "my_pep#update_timesheet_item"
                    get "/definitions" => "my_pep#get_definitions_for_timesheet"
                end   
                
                scope "/requests" do
                    get "/" => "my_pep#load_requests"
                    post "/" => "my_pep#create_request"
                    put "/cancel" => "my_pep#cancel_request"
                end
                
                get "/longterm_account" => "my_pep#get_longterm_account"
                get "/vacation_account" => "my_pep#get_vacation_account"
                get "/annual_working_time_account" => "my_pep#get_annual_working_time_account"
                get "/plan_history" => "my_pep#get_plan_history"
                get "/time_bookings" => "my_pep#get_time_bookings"
                get "/employee_rights" => "my_pep#get_employee_rights"
            end
        end
    end
end
