ServiceLayerRest::Engine.routes.draw do
  scope "/v1" do
    scope "/api" do
      scope "/staff_schedulings" do
        get "/daily_data" => "staff_schedulings#get_daily_data_all"
        
        scope "/daily_data_details" do
            put "/" => "staff_schedulings#create_daily_data_details"
            post "/" => "staff_schedulings#update_daily_data_details"
            delete "/" => "staff_schedulings#delete_daily_data_details"
        end
        
        get "/employee_data" => "staff_schedulings#get_employee_data"
        
        scope "/employee_planareas" do
            get "/" => "staff_schedulings#get_employee_planareas"
            put "/datearray" => "staff_schedulings#get_employee_planareas_for_datearray" # Should be a GET, is a PUT cause og length
        end

        get "/contract_data" => "staff_schedulings#get_contract_data"
        get "/rental_data" => "staff_schedulings#get_rental_data"
        get "/surcharge_data" => "staff_schedulings#get_surcharge_data"
        get "/longterm_account" => "staff_schedulings#get_longterm_account"
        get "/vacation_account" => "staff_schedulings#get_vacation_account"
        get "/annual_working_time_account" => "staff_schedulings#get_annual_working_time_account"
        get "/plan_history" => "staff_schedulings#get_plan_history"
                
        scope "/timesheet" do
            get "/" => "staff_schedulings#get_timesheet"
            put "/" => "staff_schedulings#update_timesheet"
            post "/" => "staff_schedulings#create_timesheet"
            delete "/" => "staff_schedulings#delete_timesheet"
        end
        
        scope "/release_working_times" do
            get "/" => "staff_schedulings#get_release_working_times"
            post "/" => "staff_schedulings#create_release_working_times"
        end
        
        scope "/working_time_entries" do
            get "/" => "staff_schedulings#get_working_time_entries"
            post "/" => "staff_schedulings#create_working_time_entries"
        end
        
        put "/month_confirmation" => "staff_schedulings#update_month_confirmation"
        get "/pinboard" => "staff_schedulings#get_pinboard"
        get "/employee_assignment_period" => "staff_schedulings#get_employee_assignment_period"
      end
    end
  end
end
