require 'service_layer_rest/dependencies'

module ServiceLayerRest
  class Engine < ::Rails::Engine
    isolate_namespace ServiceLayerRest

    config.autoload_paths += Dir[File.join(ServiceLayerRest::Engine.root, "lib", "devise", "models", "*.rb")].each { |l| require l }
    config.autoload_paths += Dir[File.join(ServiceLayerRest::Engine.root, "lib", "devise", "strategies", "*.rb")].each { |l| require l }
    puts "Autoload: #{config.autoload_paths}"

    config.generators do |g|
      g.test_framework :rspec
      g.fixture_replacement :factory_girl, :dir => 'spec/factories'
    end
  end
end
